#ifndef __NETSIM_H__
#define __NETSIM_H__

#include <iostream>
#include <queue>
#include <vector>

#include <data/xmipp_image.h>

/*
this implement some auxiliary function
*/

//auxiliary struct for sort function
struct Elem{
	int index;
	double value;
	Elem(int i, double v){index=i;value=v;}
};

//cmp for sort function
struct Cmp{
	bool reverse=false;
	Cmp(bool isreverse=false){reverse=isreverse;}
	bool operator()(Elem l, Elem r){
		if(reverse)
			return l.value>r.value;
		else
			return l.value<r.value;
	}	
};

//function to create adjacent matrix
void CreateAdjacentMatrix(MultidimArray<double> &SimIn, MultidimArray<double> &Out, int k, const Cmp cmp);
void CreateAdjacentMatrix(std::vector<double> &SimIn, std::vector<double> &Out, int k, const Cmp cmp);

//local Similarity measurement
//SimIn is input adjacent matrix and output SimOut is structural similarity measurement
void SNN(MultidimArray<double> &SimIn, MultidimArray<double> &SimOut, int k, const Cmp cmp);
void JaccardIndex(MultidimArray<double> &SimIn, MultidimArray<double> &SimOut, int k, const Cmp cmp);
void SorensenIndex(MultidimArray<double> &SimIn, MultidimArray<double> &SimOut, int k, const Cmp cmp);
void HDIndex(MultidimArray<double> &SimIn, MultidimArray<double> &SimOut, int k, const Cmp cmp);
void RAIndex(MultidimArray<double> &SimIn, MultidimArray<double> &SimOut, int k, const Cmp cmp);
void LPIndex(MultidimArray<double> &SimIn, MultidimArray<double> &SimOut, int k, const Cmp cmp, double eps);

//global similarity measurement
void KatzIndex(MultidimArray<double> &SimIn, MultidimArray<double> &SimOUt, int k, const Cmp cmp, double beta);

#endif
