# NCEM Installation Guide


NCEM is a network structural similarity metric-based clustering protocol for noisy cryo-EM single particle images.<br >
NCEM code is written in C++ and Python2.7.<br >
NCEM offers two options to calculate image similarity in initial network construction step, correlation and correntorpy.Experiments show that there's no big difference, so we recommand correlation. Because its efficiency and purely python implementation.<br>

## Dependencies 
NCEM depends on `XMIPP`'s standalone program (`xmipp_image_align`) to perform alignment and its API to pferform image IO when calculating correntorpy. <br>
Other dependencies are:<br >
* C++
    * MPI
* Python
    * Numpy, Sklearn

## Build NCEM
NCEM is easy to build, you only need to build C++ part by typing `make`

## Usage and Output
To run NCEM:<br >
    `python main.py --img_path /path/to/image --K K --num_class N --correlation True/False`<br>
where K is the *K* for mutual-KNN-network and *N* is the number of classes you want NCEM to output. *--correlation* is a bool parameter, indicating to use correlation or correntropy<br>
NCEM implements six kind of structure similarities, so it output six kind of class centers, which are `HD_centers.stk`,  `Jaccard_centers.stk`,  `Katz_centers.stk`,  `LHN2_centers.stk`,  `RA_centers.stk` and  `Sorensen_centers.stk`. You can use either of them in the following procedure.

## Contact
HongBin Shen: hbshen@sjtu.edu.cn <br>
Shuo Yin: yin1203014@sjtu.edu.cn
