import utils
import sys
import time
import argparse

def main(img_path, K, Kn, correlation=False):
    start = time.time()
    utils.align_images(img_path)
    end = time.time()
    print 'align costs %f seconds\n'%(end-start)
    if not correlation:
        adj = utils.getadj(8,K)
    else:
        corr = utils.getcorr()
        adj = utils.mutualKNN(corr, K)
    end = time.time()
    print 'align+adj costs %f seconds\n'%(end-start)
    utils.clustering('./align.stk', adj, lambda x:x, K, Kn, correlation)
    utils.clustering('./align.stk', adj, utils.Jaccard, K, Kn, correlation)
    utils.clustering('./align.stk', adj, utils.HD, K, Kn, correlation)
    utils.clustering('./align.stk', adj, utils.RA, K, Kn, correlation)
    utils.clustering('./align.stk', adj, utils.Sorensen, K, Kn, correlation)
    utils.clustering('./align.stk', adj, utils.Katz, K, Kn, correlation, 2)
    utils.clustering('./align.stk', adj, utils.LHN2, K, Kn, correlation, 0.4)

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='this is some description')
    parser.add_argument('--img_path', type=str, help='file name contain images')
    parser.add_argument('--K', type=int, help='K in KNN network')
    parser.add_argument('--num_class', type=int, help='number of class')
    parser.add_argument('--correlation', type=bool, help='use correlation or correntropy', default=False)
    args = parser.parse_args()
    print(args)
    main(args.img_path, args.K, args.num_class, args.correlation)
